                     Marvell FCode Driver Release Notes
                        Marvell Semiconductor, Inc.
                           All rights reserved.


Table of Contents

1. Change History
2. Known Issues
3. Notices
4. Contacting Support


1. Change History

These release notes describe the changes, fixes, known issues, and release 
details that apply to the FCode for the 26xx and 27xx Fibre Channel and the
83xx Converged Network Adapters (FCoE) Adapters. 


1.1. FCode Version History

version 4.11 4/15/20
* Updated file header QLogic to Marvell and added copyright in Release notes and Readme files

version 4.11 3/14/16
* ER135917 Change version string from 4.11b6 to 4.11 (new official release).


version 4.11b6 3/08/16
* ER135917 Update show-settings for Baker to show current active-flash-image..


version 4.11b5 3/05/16
* ER135917 Update flash-utility to include bootcode in the FW-Set for ld-image.

version 4.11b4 3/01/16
* ER135917 Update flash_utility, add PEP SoftROM FW section to ldfw-pep method
* Change all readme files to specify SPARC or PPC IBM platform. 
* Fix bug on Baker/Qlipper that shows set-personality in show-commands menu.

version 4.11b3 2/22/16
* ER138668 Add Baker and Qlipper support for IBM PPC platforms.
* Added SSDID 02ad, QLE2694U Bombay Upgrade & fix 02a2, QLE2694L Brighton SSDID.
* Fix ssdid>adapter bug when SSDID=unknown. Used at probe-time for adapter prop

version 4.11b2 7/15/15
* ER135917 Add Qlipper DID 2261 and check Feature Mask for 32Gb support.
* Remove Model# from from version property, this was confusing for Oracle Models

version 4.11b1 6/15/15
* ER135917 Update flash_utility, skip fix-headers for Baker VFs. Add 2700Readme.

version 4.10 5/25/15
* ER135917 Change version string from 4.10b7 to 4.10 (new official release).

version 4.10b7 5/22/15
* ER135917 Change VF model string prop extraction to use SSDID ssdid>model.
* Added SSDID 02a5, QLE2684L Carme & 029e, QLE2694L Brighton to Device ID list.

version 4.10b6 4/24/15
* ER135917 Remove Cfg-space VF VPD access. It is not accessable to the VFs.
* Now we get the Model string from the PF, at the same time we get the WWPN.
* Add Primary & Secondary Image Status access in Flash for execute and updates

version 4.10b5 3/26/15
* ER135917 Add Cfg-space VPD access for VF. Add model & product-id properties.
* ER135964 Update SSIDs for BAKER & HIDLA adapter property in ssdid>adapter.

version 4.10b4 3/20/15
* ER135578 Add SSDID x29f for Oracle Oceanside Tiger. This is a SUNW device.

version 4.10b3 3/19/15
* ER135578 Change Tiger DIDs to x2971 and x2d71 (VF). Also allow for 1-port HBA.

version 4.10b2 3/04/15
* ER135578 Fix set-data-rate to allow only 4, 8, & 16G for all QLE26xx adapters.
* Change all Copyright strings in source files to 2015.

version 4.10b1 10/30/14
* ER134495 Add port-wwn and node-wwn properties for VFs. Created when opened.

version 4.09 9/12/14
* ER132896 Change version string from 4.09b2 to 4.09 (new official release).

version 4.09b2 9/08/14
* ER132896 Remove Dport reverences from Readme and forth source files.
* BAKER only: Fix flash-cfg! method sector-offset and also fix probe banner.

version 4.09b1 8/29/14
* ER132896 Fix fp.fth bug. Add missing methods: read-block-ext64 & rw-blocks64
  These methods add 64-bit LBA support. This bug only present in SUN qlc Fcode

version 4.08 8/11/14
* ER132896 Fix bug introduced in 4.07b3 when my-func replaced port1?.

version 4.07 7/30/14
* ER132896 Change version string from 4.07b4 to 4.07 (official FAPWWN release).

version 4.07b4 6/12/14
* ER132896 Fix stack bug introduced in 4.07b3 when executing fcoe? word.
* Cleanup 8080 AEN Dport messages and also display SFP info on debug-init?.
* Remove set-fapwwn-ena and set-dport-ena from the FCoE ISP8031 build.
* Fix bug in ILT Flash utility when searching Card-Type-Lists, search-ctls word.

version 4.07b3 5/22/14
* ER132896 Add support for Baker 2700 family adapters including Gruber & Tiger.

version 4.07b2 5/13/14
* Remove qla support
* fix bug introduced in version 4.07b1, which affected SNS command execution.

version 4.07b1 5/1/14
* Add Fabric-Assign WWPN & DPort-Diag features with NVRAM en/disable commands.

version 4.06 3/11/14
* ER106574 Change version string from 4.06b14 to 4.06 (official SR-IOV release).
* Change all Copyright strings in source files to 2014.

-Non SR-IOV changes from version 4.05 to 4.06. 
* Fix bug in retry? method. It was not retring Queue Full 28 SCSI status.
* Add debug-scsi? "Retry command, #retries left  = #".
* Change re-login to return cmp-status on failure, not -1.
* Fix login-device to Logout-device when login times out(sub-cmd 4).
* Created NPort-Header buffer, nph-buf. Allows skipping invalid NPHs.
* Fix check-ctype to check default(0) Card-Type-List when flashing ILT.
* Removed the display of PHY version in show-fw-version. It was invalid.
* Add the display of Multi-Flash-version in show-settings.
* Use interrput-status constants aen-int(x12) and rspq-int(x14), not literals.
* Fix old bug in get-port-db for debug message 'Port-DB cmd failed - phandl='.

version 4.06b14 2/4/14
* ER106574 Fix bug in retry? method. It was not retring Queue Full 28 status.

version 4.06b13 2/3/14
* ER106574 Put send-marker IOCB back in VF Fcode. It was taken out by mistake.
* Add debug-scsi? "Retry command, #retries left  = #".
* Change re-login to return cmp-status on failure, not -1.

version 4.06b12 12/13/13
* ER106574 Put back the 'version' property for VFs, but without the model #.
* Add 'show-commands' command for VFs. The commands are very limited.

version 4.06b11 11/18/13
* ER106574 Fix login-device to Logout-device when login timesout(sub-cmd 4).
* Created NPort-Header buffer, nph-buf. Allows skipping invalid NPHs.

version 4.06b10 10/17/13
* ER106574 Fix check-ctype to check default(0) Card-Type-List when flashing ILT.
* Add Adapter PortID display in show-settings.

version 4.06b9 09/11/13
* ER106574 Fix PF boot-code flash utility to not overwrite VF image DevID.

version 4.06b8 08/23/13
* ER106574 Add unconditional stop-risc to start VF initialization. VF reset-risc

version 4.06b7 08/21/13
* ER106574 Removed init rsp-out-ptr & req-in-ptr in init-vf-fw. Also changed ICB
* Removed the display of PHY version in show-fw-version. It was invalid.
* Fixed the display of Multi-Flash-version in show-settings on the PF.

version 4.06b6 07/25/13
* ER106574 Fixed bug in v4.06b5 in login-loop for VFs.
* Added Multiflash Version display in show-settings for the PF.

version 4.06b5 07/16/13
* ER106574 Create constants for aen-int(x12) and rspq-int(x14) in structs.fth.
* Fix old bug in get-port-db for debug message 'Port-DB cmd failed - phandl='.
* Added Function #, VF Index, and Port to show-settings. Passed by vdc-config.
* Got VDC commands working with Solaris Driver. The link is up.
* Add Resp-Queue-out pointer check to detect Response-Queue Update interrupt.

version 4.06b4 06/07/13
* ER106574 Finished Segregating PF and VF code using #ifdef VF throughout.
* Created utility words to load multiple BIN files. Fcode is now seen on the VF

version 4.06b3 06/03/13
* ER106574 Change makefile to make a separate bin file with DEVID=2431 for VFs
* Change selftest.fth and properties.fth to use #ifdef VF, not vf? flag.

version 4.06b2 05/24/13
* ER106574 Added SRIOV Mailbox command x5f Send VDC (Virt Driver Comm) message

version 4.06b1 03/13/13
* Change header on Readme and Release-Note files.
* Move sel-my-nvram call to init-flt-offsets. Affects init version only.
* Reorganize some methods in init-isp.fth and reg-isp.fth.

version 4.05 02/07/13
* ER103657: Add access to extended-capabilities in config-space beyond 256-byte.
* Fixed bug in beacon test (update to current FW spec), for FC and FCoE.
* Remove props not supported on PCIe devices, fast-b-to-b, 66mhz-cap, min-grant

version 4.04 01/08/13
* ER102374: Display Product-ID string in VPD area during initial selection.
* Also create a product-id and part# property and display in show-settings.

version 4.03 12/20/12 
* ER101866: Remove user access to set-function-config. Done in NIC Fcode.
* Add methods to access VPN data on IBM Sensei only.

version 4.02 11/12/12 
* CR7206046: Change version string from 4.02b6 to 4.02 (official release).
* Add 3 second delay to restart-nic mailbox command (FCoE only).
* Remove check for IBM mezz card in set-connection-mode (FC16 only).

version 4.02b6 11/07/12 
* CR7206046: Change sunid? node name back to SUNW from ORCL due to luxadm bug.

version 4.02b5 10/04/12 
* ER98905: Add show-function-config to show current active-function-config.
* ER98915: Add set-function-config to set active-func-config based on capability
* show-function-config will also show the Function MAC address to match BIOS.
* Change set-personality to use show-function-config not func-enable-map.
* Change source and Readme files Copyright from 2011 to 2012.

version 4.02b4 08/23/12 
* ER97730: Add check of user-changable-personality bit in the Flash Feature
  Exclusivity word, before allowing the end-user to set-personality.
* Update the FC_FcodeReadme_PPC.txt and FC_FcodeReadme_SPARC.txt documents.

version 4.02b3 08/06/12 
* ER95913: Remove -A0 or -B0 chip Rev ID to version string. Put in v4.02b2.
* Fix bug in fix-rbios and ldbc-nic which allows flashing of NIC boot-code.

version 4.02b2 07/17/12 
* ER95913: Change wording on the set-personality word to say: FC only.
* Add -A0 or -B0 chip Rev ID to version string.

version 4.02b1 06/22/12 
* ER94574: Fix stack bug in .adatper-info, found in blade hotplug test by efcode

* Add BIOS fix-images to the Flash utility for ILT Bootcode images. Add ldbc-is.

version 4.01 05/09/12 (first release to DVT)
* Add check of oscillator bits in Feature-Mask before changing personality.
* Add checksum setting in Feature-Config Flash area.
* Add more fixes to FCoE internal and external loopback tests.
* Add setting my-fcfi(FCF Index) in get-id mbox command. Used in diag-lb test.

version 4.01b12 03/30/12
* Make validate-nvram silent. Print messages only if debug-flash?(x1000) is set.
* Add iSCSI flash utility word: ldbc-is and change names to ldbc-fc & ldbc-fcoe.
* Fix bugs in find-ilt-code so all Card-Type-Lists will be searched for SSDID.
* Rework Internal and External Loopback tests. Now working on FC functions.
* Remove pasue-risc from nvr-wd@ word.

version 4.01b11 02/10/12
* Add loop words selftest-loop and ext-lb-test-loop for testing.
* Add support for AEN 8200 NIC-FW change notfication.


version 4.01b10 01/31/12
* Add 5 sec timeout in ?handle-ae-ints. Work-around for stuck 8030 int in loop.
* Remove disabling of EXPROM (dis-exp) from enab-reg-acc. Not needed.

version 4.01b9 01/18/12
* Add dynamic sizing of BARs with size-bars, executed in isp-probe for reg prop
* Fix get-port-cfg stack bug for failed case & add reason code for rstart-nic.

version 4.01b8 01/11/12
* Fix typo in v4.01b7. Change Oracle node-name from QRCL,qlc to ORCL,qlc.
* Change the wording on the set-personality command (ER88600).

version 4.01b7 12/16/11
Fix bug in v4.01b6. Move set-std-props in isp-probe so regs are mapped for Flash

version 4.01b6 12/09/11
* Changed node-name from SUNW,qlc to ORCL.qlc for Oracle/SUN Dev-ID adapters.
* Change oem property to QLogic or Oracle, and manufacture property to QLogic.
* Removed search for FLT Locator in flash boot-image. Not used on Hilda.
* Added SUN Dev-ID 024d, 024f, 0251 and 0253 to sunid? word.
* Fixed error handling of 400C status on the Diag-loopback test.

version 4.01b5 11/09/11
* FCoE driver is now working. Fixed fip-macadr@ word so MAC-Addr is correct.
* Fixed bug in sel-port[0|1]-nvram words for FCoE, now NVRAM is working.
* Fixed bug in version banner. FC and FCoE were swapped.
* Added "A Power-cycle is required ..." in set-personality for A0-chips.
* Added the ability to flash all raw FW binaries and FCoE Fcode from FC driver

version 4.01b4 10/28/11
* Set-personality method is now working. It modifies the Feature Config Word.
* Create secbuf-adr+ & secbuf-wd! so sav-sec pgm-sec can be used for any sector
* Added Long-Byte-Clear words to utils.fth to be used in flash-b!.

version 4.01b3 09/29/11
* Show-children now working. Add Enable-Interrupt-Handshake to FW opt2 in ICB.

version 4.01b2 08/24/11
* Init-chip works. Fixed MBAR reg offsets, ifpcsr! read-back, & isp-load-addr.

version 4.01b1 08/17/11
* Initial check-in.


2. Known Issues  

None 


3. Notices

Information furnished in this document is believed to be accurate and
reliable. However, QLogic Corporation assumes no responsibility for
its use, nor for any infringements of patents or other rights of
third parties which may result from its use. QLogic Corporation
reserves the right to change product specifications at any time
without notice. Applications described in this document for any of
these products are only for illustrative purposes. QLogic Corporation
makes no representation nor warranty that such applications are
suitable for the specified use without further testing or
modification. QLogic Corporation assumes no responsibility for any
errors that may appear in this document.

4. Contacting Support

   For further assistance, contact QLogic Technical Support at:
   http://support.qlogic.com


Trademarks 

Accelera, Accelerating Cluster Performance, InfiniCon Systems, 
InfiniNIC, InfiniPath, InfiniView, QLA, QLogic, the QLogic logo, 
ReadyPath, SANdoctor, SANsurfer, and SilverStorm are registered 
trademarks of QLogic Corporation. All other brand and product names 
are trademarks or registered trademarks of their respective owners. 



(c) Copyright 2020. All rights reserved worldwide. Marvell, the Marvell
logo, and the Powered by Marvell logo are registered trademarks of
Marvell Semiconductor, Inc. All other brand and product names are trademarks
or registered trademarks of their respective owners.

